patching the delmailuser script to function properly (+ refactoring)

This commit is contained in:
Georg Lauterbach 2021-02-14 21:19:58 +01:00
parent 5a806b9934
commit 227719ee0d
No known key found for this signature in database
GPG key ID: 2FDC58699AF121C6
2 changed files with 50 additions and 43 deletions

View file

@ -1,9 +1,9 @@
#! /bin/bash #! /bin/bash
# shellcheck disable=SC2094
# ? This is done to ignore the message "Make sure not to read and write # ? This is done to ignore the message "Make sure not to read and write
# ? the same file in the same pipeline", which is a result of ${DATABASE} # ? the same file in the same pipeline", which is a result of ${DATABASE}
# ? being used below. (This disables the message file-wide.) # ? being used below. (This disables the message file-wide.)
# shellcheck disable=SC2094
# shellcheck source=../scripts/helper-functions.sh # shellcheck source=../scripts/helper-functions.sh
. /usr/local/bin/helper-functions.sh . /usr/local/bin/helper-functions.sh
@ -11,82 +11,98 @@
DATABASE=${DATABASE:-/tmp/docker-mailserver/postfix-accounts.cf} DATABASE=${DATABASE:-/tmp/docker-mailserver/postfix-accounts.cf}
ALIAS_DATABASE="/tmp/docker-mailserver/postfix-virtual.cf" ALIAS_DATABASE="/tmp/docker-mailserver/postfix-virtual.cf"
QUOTA_DATABASE="/tmp/docker-mailserver/dovecot-quotas.cf" QUOTA_DATABASE="/tmp/docker-mailserver/dovecot-quotas.cf"
MAILDEL=false
function usage function usage
{ {
echo "Usage: delmailuser <-y> <user@domain> <user2@anotherdomain> ..." echo "Usage: delmailuser [-y] <user@domain> [<user2@anotherdomain>]"
echo " -y: don't prompt for confirmations"
} }
while getopts ":y" OPT while getopts ":yY" OPT
do do
case ${OPT} in case ${OPT} in
y) y | Y )
MAILDEL="y" MAILDEL=true
;;
\?)
usage
errex "Invalid option: -${OPTARG}"
;; ;;
* ) * )
usage usage
errex "Invalid option: -${OPTARG}" exit 1
;; ;;
esac esac
done done
shift $((OPTIND-1)) shift $((OPTIND-1))
[[ -z ${*} ]] && { usage ; errex "No user specifed" ; } [[ -z ${*} ]] && { usage ; errex "No user specifed" ; }
[[ -s ${DATABASE} ]] || exit 0 [[ -s ${DATABASE} ]] || exit 0
# Protect config file with lock to avoid race conditions if ! ${MAILDEL}
then
read -r -p "Do you want to delete the mailbox as well (removing all mails) ? [Y/n] " MAILDEL_CHOSEN
[[ ${MAILDEL_CHOSEN} =~ (y|Y| ) ]] && MAILDEL=true
fi
( (
flock -e 200 flock -e 200
for USER in "${@}" for USER in "${@}"
do do
# very simple plausibility check # very simple plausibility check
[[ ${USER} != *"@"*"."* ]] && errex "No valid address: ${USER}" [[ ${USER} != *'@'*'.'* ]] && errex "No valid address: ${USER}"
declare -a MAILARR declare -a MAILARR
MAILARR[0]="${USER%@*}" MAILARR[0]="${USER%@*}"
MAILARR[1]="${USER#*@}" MAILARR[1]="${USER#*@}"
# XXX ${USER} must not contain /s and other syntactic characters # ${USER} must not contain /s and other syntactic characters
USER=$(escape "${USER}") USER=$(escape "${USER}")
if ! sed -i "/^""${USER}""|/d" "${DATABASE}" if [[ -f ${DATABASE} ]]
then
if ! sed -i "/^${USER}|/d" "${DATABASE}"
then then
errex "${USER} couldn't be deleted in ${DATABASE}. ${?}" errex "${USER} couldn't be deleted in ${DATABASE}. ${?}"
fi fi
fi
# Delete all aliases where the user is the only recipient( " ${USER$}" ) if [[ -f ${ALIAS_DATABASE} ]]
# Delete user only for all aliases that deliver to multiple recipients ( ",${USER}" "${USER,}" )
if sed -i -e "/ ""${USER}""$/d" \
-e "s/,""${USER}""//g" \
-e "s/""${USER}"",//g" "${ALIAS_DATABASE}"
then then
echo "${USER} and potential aliases deleted." || errex "Aliases for ${USER} couldn't be deleted in ${ALIAS_DATABASE}. ${?}" # delete all aliases where the user is the only recipient( " ${USER$}" )
# delete user only for all aliases that deliver to multiple recipients ( ",${USER}" "${USER,}" )
if sed -i \
-e "/ ${USER}$/d" -e "s/,${USER}//g" -e "s/${USER},//g" \
"${ALIAS_DATABASE}"
then
echo "${USER} and potential aliases deleted."
else
errex "Aliases for ${USER} couldn't be deleted in ${ALIAS_DATABASE}."
fi
fi fi
# remove quota directives # remove quota directives
if [[ -f ${QUOTA_DATABASE} ]] if [[ -f ${QUOTA_DATABASE} ]]
then then
sed -i -e "/^${USER}:.*$/d" "${QUOTA_DATABASE}" || errex "Quota for ${USER} couldn't be deleted in ${QUOTA_DATABASE}. ${?}" if ! sed -i -e "/^${USER}:.*$/d" "${QUOTA_DATABASE}"
fi
if [[ ${MAILDEL} != "y" ]]
then then
read -r -p "Do you want to delete the mailbox as well(all mails will be removed)?(y/n) " MAILDEL errex "Quota for ${USER} couldn't be deleted in ${QUOTA_DATABASE}."
echo fi
fi fi
[[ ${MAILDEL} != "y" ]] && errex "Leaving the mailbox untouched. If you want to delete it at a later point use \"sudo docker exec mail rm -R /var/mail/${MAILARR[1]}/${MAILARR[0]}\"" if ! ${MAILDEL}
then
echo "Leaving the mailbox untouched. If you want to delete it at a later point use 'sudo docker exec mail rm -R /var/mail/${MAILARR[1]}/${MAILARR[0]}'"
exit 0
fi
if [[ -d "/var/mail/${MAILARR[1]}/${MAILARR[0]}" ]]
then
if rm -r -f "/var/mail/${MAILARR[1]}/${MAILARR[0]}" if rm -r -f "/var/mail/${MAILARR[1]}/${MAILARR[0]}"
then then
echo "Mailbox deleted." || errex "Mailbox couldn't be deleted: ${?}" echo "Mailbox deleted."
else
errex "Mailbox couldn't be deleted."
fi
else
errex "Mailbox directory '/var/mail/${MAILARR[1]}/${MAILARR[0]}' does not exist."
fi fi
done done

View file

@ -86,7 +86,6 @@ function register_functions
################### >> check funcs ################### >> check funcs
_register_check_function "_check_environment_variables"
_register_check_function "_check_hostname" _register_check_function "_check_hostname"
################### >> setup funcs ################### >> setup funcs
@ -308,7 +307,7 @@ function check
function _check_hostname function _check_hostname
{ {
_notify "task" "Check that hostname/domainname is provided or overridden (no default docker hostname/kubernetes) [in ${FUNCNAME[0]}]" _notify "task" "Check that hostname/domainname is provided or overridden [in ${FUNCNAME[0]}]"
if [[ -n ${OVERRIDE_HOSTNAME} ]] if [[ -n ${OVERRIDE_HOSTNAME} ]]
then then
@ -319,21 +318,13 @@ function _check_hostname
_notify 'inf' "Domain has been set to ${DOMAINNAME}" _notify 'inf' "Domain has been set to ${DOMAINNAME}"
_notify 'inf' "Hostname has been set to ${HOSTNAME}" _notify 'inf' "Hostname has been set to ${HOSTNAME}"
if ( ! grep -E '^(\S+[.]\S+)$' <<< "${HOSTNAME}" >/dev/null ) if ! grep -q -E '^(\S+[.]\S+)$' <<< "${HOSTNAME}"
then then
_notify 'err' "Setting hostname/domainname is required" _notify 'err' "Setting hostname/domainname is required"
kill "$(< /var/run/supervisord.pid)" && return 1 kill "$(< /var/run/supervisord.pid)" && return 1
else
return 0
fi fi
} }
function _check_environment_variables
{
_notify "task" "Check that there are no conflicts with env variables [in ${FUNCNAME[0]}]"
return 0
}
########################################################################## ##########################################################################
# << Check Stack # << Check Stack
########################################################################## ##########################################################################